package de.fhdw.wtf.generator.java.generatorModel;

import java.util.Vector;

import de.fhdw.wtf.generator.java.visitor.GenClassClassVisitor;
import de.fhdw.wtf.generator.java.visitor.GenClassClassVisitorException;
import de.fhdw.wtf.generator.java.visitor.GenClassClassVisitorReturn;

public final class GenJavaException extends GenClassClass {
	
	private static final String EXCEPTION = "Exception";
	
	private GenJavaException(final GenPackage packag) {
		// FIXME Überschreiben und null werte nicht schön!
		super(EXCEPTION, null, null, null, null, new Vector<GenJavaOperation>(), null, packag, null, null);
	}
	
	@Override
	public void setExtend(final GenClassClass ext) {
		// nothing to do
	}
	
	public void addOperation(final GenOperation newOperation) {
		// nothing to do
	}
	
	public static GenJavaException createJavaException(final GenPackage packag) {
		return new GenJavaException(packag);
	}
	
	@Override
	public void accept(final GenClassClassVisitor visitor) {
		visitor.handle(this);
	}
	
	@Override
	public <X> X accept(final GenClassClassVisitorReturn<X> visitor) {
		return visitor.handle(this);
	}
	
	@Override
	public <Y extends Exception> void accept(final GenClassClassVisitorException<Y> visitor) throws Y {
		visitor.handle(this);
	}
}
